package demo7;

import java.util.Iterator;

public class File<E> implements Iterable<E> {
	protected class Noeud<F> {
		public F element;
		public Noeud<F> suivant;
		
		public Noeud( F element ) {
			this.element = element;
			this.suivant = null;
		}
	}
	
	public class FileIterator implements Iterator<E> {
		Noeud<E> courrant;
		
		public FileIterator( File<E> source ) {
			courrant = source.debut;
		}
		
		@Override
		public boolean hasNext() {
			return null != courrant;
		}

		@Override
		public E next() {
			E resultat = courrant.element;
			
			courrant = courrant.suivant;
			
			return resultat;
		}
	}
	
	@Override
	public Iterator<E> iterator() {
		return new FileIterator( this );
	}
	
	private Noeud<E> debut = null;
	private Noeud<E> fin   = null;
	private int nbElement  = 0;

	public File() {
	}
	
	public int taille() {
		return nbElement;
	}
	
	public boolean estVide() {
		return 0 == nbElement;
	}
	
	public E tete() throws FileVide{
		if( null == debut ) {
			throw new FileVide();
		}
		
		return debut.element;
	}
	
	public void enfiler( E element ){
		Noeud<E> nouveau = new Noeud<>( element );
		
		if( null != fin ){
			fin.suivant = nouveau;
		}
		
		fin = nouveau;
		
		if( null == debut ){
			debut = nouveau;
		}
		
		++ nbElement;
	}
	
	public void defiler() throws FileVide{
		if( null == debut ) {
			throw new FileVide();
		}
		
		if( fin == debut ){
			fin = null;
		}
		
		debut = debut.suivant;
		
		-- nbElement;
	}
	
	public void t( File< E > f2 ) {
		if( null == fin ) {
			debut = f2.debut;
		} else {
			fin.suivant = f2.debut;
		}
		
		if( null != f2.fin ) {
			fin = f2.fin;
		}
		
		nbElement += f2.nbElement;
	}

}
